/* beginner.c ********************************* updated: 1997-07-25 08:21 TT
 *
 * Author      : Tormod Tjaberg
 * Created     : 1997-05-08
 * Description : Determine interface type needed
 */
#include <stdlib.h>
#include <stdio.h>

#if defined(__DJGPP__)
#include <sys/farptr.h>
#include <go32.h>
#else
/* Fake things a little bit for the other compilers */
#define _dos_ds   0
#include <dos.h>

unsigned short _farpeekw(unsigned short Selector, unsigned long Offset)
{
#if defined(__386__)  /* Watcom DOS4GW */
   return *((unsigned short *) Offset);
#elif defined(DOS386) /* Symantec, Zortech, DOSX, PHARLAP */
   return *((unsigned short far *) MK_FP(_x386_zero_base_selector, Offset));
#else
   return *((unsigned short far *) Offset);
#endif
}
#endif


/* Input  : port number (1 - 4)
 * Returns: -1 - port number out of range 
 *          -2 - invalid printer port specified
 *           0 - support for 1 fire button
 */
short CheckInterface(short PortNum)
{
   unsigned short DataRegAddr;
   unsigned short StatusRegAddr;
   unsigned char OldDataRegVal;

   if (PortNum < 1 || PortNum > 4)
      return -1;

   DataRegAddr = _farpeekw(_dos_ds, 0x40 * 16 + 0x8 + ((PortNum - 1) * 2));

   if (DataRegAddr == 0)
      return -2;

   StatusRegAddr = DataRegAddr + 1;
   OldDataRegVal = inp(DataRegAddr);

   outp(DataRegAddr, 0xff);
   if (((inp(StatusRegAddr) >> 3) & 0x1f) != 0xf)
   {  
      outp(DataRegAddr, OldDataRegVal);
      return -3;
   }

   outp(DataRegAddr, OldDataRegVal);
   return 0;
}

int main(int argc, char *argv[])
{
   short i;
   short s;

   puts("beginner, ver 1.00 -- Copyright (C) 1997 Tormod Tjaberg\n");
   puts("Usage: beginner <port number>\n");

   puts("This program will test if your PC is compatible with the \"beginner\"");
   puts("digital joystick interface (only one fire button). Make sure that");
   puts("nothing is plugged into the parallel port before running this program.\n");

   if (argc == 1)
   {
      puts("command error, missing parallel port number 1 - 4");
      return 1;
   }

   s = argv[1][0] - '0';
   i = CheckInterface(s);

   if (i < 0)
   {
      switch(i)
      {
         case -1: printf("command error, port number %d is out of range (1-4)\n", s); break;
         case -2: printf("error, parallel port %d does not exist\n", s); break;
         case -3: printf("sorry, your parallel port %d does not support the \"beginner\" interface\n", s); break;
         default: printf("InitDigJoy returns %d\n", i); break;
      }
      return 1;
   }

   printf("Your parallel port %d supports the \"beginner\" parallel interface.\n", s);

   return 0;
}
